#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include <unistd.h>

#include <sys/times.h>

#include <unistd.h>
#include <limits.h>
#include <sys/param.h>

extern "C" {
  int gethostname(char *name, int namelen);
}

#define MAXNUM 5 

#include "adlib.h"

/*
extern "C" {
#include <mpi.h>
#include <stdio.h>
}
*/

extern int len;
extern char** sargs;

#include "spmd_Adlib.h"

#include "jctable.h"
extern jctable<Group> spmd_Group_Table;
//Group * spmd_Group_ResolvePtr(JNIEnv *, jobject);

DAD * spmd_DAD_ResolvePtr(JNIEnv *, jobject);

extern jfieldID hCPPObjID;

/*
 * Class:     spmd_Adlib
 * Method:    _aprintf
 * Signature: (Ljava/lang/String;Lspmd/DAD;ILjava/lang/Object;I)V
 */
JNIEXPORT void JNICALL Java_spmd_Adlib__1aprintf
  (JNIEnv * env, jclass jAdlib, 
   jstring ctr, 
   jobject jDAD, jint type, jobject ref, jint ost)
{
  int length=env->GetStringUTFLength(ctr);
  char * cCtr=new char[length+1];

  const char * jctrPtr=env->GetStringUTFChars(ctr, 0);

  for (int i=0; i<length; i++)
    cCtr[i]=*(jctrPtr+i);
  cCtr[length]='\0';

  env->ReleaseStringUTFChars(ctr, jctrPtr);

  DAD * dad=spmd_DAD_ResolvePtr(env, jDAD);

  void * data;
  jint * intArray;
  jfloat * floatArray;
  
  int len;

  switch (type) {
  case 4:
    intArray=env->GetIntArrayElements((jintArray)ref, 0);
    data=(void *)(intArray+ost);
    len=4;
    break;
  case 6:
    floatArray=env->GetFloatArrayElements((jfloatArray)ref, 0);
    data=(void*)(floatArray+ost);
    len=4;
    break;
  default:
    printf("not touched type %d\n", type);
    break;
  }

  //  AdlibPrintf("Constructing IOArg..."); //debug
  IOArg * arg=new IOArg(dad, data, len);
  //  AdlibPrintf("finished\n"); //debug


  //  AdlibPrintf("call aprintf..."); //debug
  aprintf(cCtr, arg);
  //  AdlibPrintf("finished\n"); //debug

  delete arg;

  switch (type) {
  case 4:
    env->ReleaseIntArrayElements((jintArray)ref, intArray, JNI_ABORT);
    break;
  case 6:
    env->ReleaseFloatArrayElements((jfloatArray)ref, floatArray, JNI_ABORT);
    break;
  default:
    printf("not touched type %d\n", type);
    break;

  }

  delete [] cCtr;

};

/*
 * Class:     spmd_Adlib
 * Method:    printString
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_spmd_Adlib_printString
  (JNIEnv * env, jclass jthis, jstring String) 
{
  int length=env->GetStringUTFLength(String);

  char * cString=new char[length+1];

  const char * jStringPtr=env->GetStringUTFChars(String, 0);

  for (int i=0; i<length; i++)
    cString[i]=*(jStringPtr+i);
  cString[length]='\0';

  printf("%s", cString);

  env->ReleaseStringUTFChars(String, jStringPtr);

  delete[] cString;
};


/*
 * Class:     spmd_Adlib
 * Method:    _InitAPG
 * Signature: (Lspmd/Group;)V
 */
JNIEXPORT void JNICALL Java_spmd_Adlib__1InitAPG
  (JNIEnv * env, jclass jthis, jobject jGroup)
{
  int pos = env->GetIntField(jGroup, hCPPObjID);

  delete (spmd_Group_Table.ObjPtr[pos]);

  spmd_Group_Table.ObjPtr[pos]=&apg;
};

/*
 * Class:     spmd_Adlib
 * Method:    _InitInterFace
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_spmd_Adlib__1InitInterFace
  (JNIEnv * env, jclass jthis)
{
  //to init hCPPObjID;
  jclass InterfaceObject_class=env->FindClass("spmd/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "I");
}


JNIEXPORT void JNICALL Java_spmd_Adlib__1Initialize
  (JNIEnv *env, jclass obj, jobjectArray argv) 
{
  jsize i;
  jstring jc;
  len = env->GetArrayLength(argv);

  //printf("argc=%d\n",len);

  sargs = (char**)calloc(len+1, sizeof(char*));
  for (i=0; i<len; i++) {	
    jc=(jstring)env->GetObjectArrayElement(argv,i);
    sargs[i]=new char[strlen(env->GetStringUTFChars(jc,0))];
    strcpy(sargs[i],env->GetStringUTFChars(jc,0));	

    //printf("sargs[%d]:%s\n",i,sargs[i]);
  }

  //printf("AdlibInit...\n");

  AdlibInit(len, sargs);

}

JNIEXPORT void JNICALL Java_spmd_Adlib__1Finalize
  (JNIEnv *env, jclass obj) {
  int i;

  //printf("AdlibFinalize...\n");

  AdlibFinalize();

  for (i=0; i<len; i++)
    //free(sargs[i]);
    delete [] sargs[i];
  free(sargs);
}

/*
 * Class:     spmd_Adlib
 * Method:    timer
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_spmd_Adlib_timer
  (JNIEnv * env, jclass jthis, jint jnum)
{

  static long CLKTCK = sysconf(_SC_CLK_TCK);

  static struct tms actTimeBuf[MAXNUM+1];
  static clock_t wallTimeBuf[MAXNUM+1];

  static int timeNum=0;

  static char name[25];

  // printf("....%p %d\n", &num, (jnum));

  if ((jnum) == 0 ) {
    gethostname (name, 25);
    timeNum=0;
    wallTimeBuf[timeNum]=times(& actTimeBuf[timeNum]);  
  } 
  else {
    timeNum++;

    if (timeNum > MAXNUM ) {
      printf("Maximum time is %d\n", (timeNum-1));
      exit(1);
    }

    wallTimeBuf[timeNum]=times(& actTimeBuf[timeNum]);

    //printf (" %d - %d \n",timeNum, timeNum-(jnum) );
    
    //printf ( " %ld ----- %ld \n", wallTimeBuf[timeNum], wallTimeBuf[timeNum-(jnum)] );
    
    //printf ( " %ld -- \n", CLKTCK);

    //printf ( " %ld -- %ld \n", actTimeBuf[timeNum].tms_utime, actTimeBuf[timeNum].tms_stime );

    if (timeNum < (jnum)) {
      printf ("%s, Rt: %4.3f, Ut: %4.3f, CUt: %4.3f, St: %4.3f, CSt: %4.3f\n",
              name,
              (float)(wallTimeBuf[timeNum]-wallTimeBuf[0])/CLKTCK,
              (float)(actTimeBuf[timeNum].tms_utime-actTimeBuf[0].tms_utime)/CLKTCK,
              (float)(actTimeBuf[timeNum].tms_cutime-actTimeBuf[0].tms_cutime)/CLKTCK,
              (float)(actTimeBuf[timeNum].tms_stime-actTimeBuf[0].tms_stime)/CLKTCK,
              (float)(actTimeBuf[timeNum].tms_cstime-actTimeBuf[0].tms_cstime)/CLKTCK);
    }
    else {
      printf ("%s, Rt: %4.3f, Ut: %4.3f, CUt: %4.3f, St: %4.3f, CSt: %4.3f\n",
              name,
              (float)(wallTimeBuf[timeNum]-wallTimeBuf[timeNum-(jnum)])/CLKTCK,
              (float)(actTimeBuf[timeNum].tms_utime-actTimeBuf[timeNum-(jnum)].tms_utime)/CLKTCK,
              (float)(actTimeBuf[timeNum].tms_cutime-actTimeBuf[timeNum-(jnum)].tms_cutime)/CLKTCK,
              (float)(actTimeBuf[timeNum].tms_stime-actTimeBuf[timeNum-(jnum)].tms_stime)/CLKTCK,
              (float)(actTimeBuf[timeNum].tms_cstime-actTimeBuf[timeNum-(jnum)].tms_cstime)/CLKTCK);
    }
  }

}
